%GETSCALINGFROMTHREEVIEWS Summary of this function goes here
%
% Usage: [ errorMap ] = getScalingFromThreeViews(x1, x2, x3, P1, P2, K1, K2, K3)
%
function [ scale ] = getScalingFromThreeViews(x1, x2, x3, P1, P2, K1, K2, K3)

if nargin~=8
    error('Missing arguments.');
end

[C1 R1] = getCRfromP(P1);
[C2 R2] = getCRfromP(P2);

npts = size(x1,2);

% reconstruct points between first two views
X1 = reconstructPoint(x1,x2,eye(3),zeros(3,1),R1,C1,K1,K2);

% reconstruct 3d points between second and third image
X2 = reconstructPoint(x2,x3,R1,C1,R1*R2,R1*C2,K2,K3);


% for i=1:npts

    % check square distance between corresponding reconstructed 3d points

    
% end

distsX1X2 = sqrt(sum((X2-X1).^2));

distsC0X1 = sqrt(sum(X1.^2));
distsC1X1 = sqrt(sum((X1-repmat(C1,1,npts)).^2));
distsC1X2 = sqrt(sum((X2-repmat(C1,1,npts)).^2));

%scales = distsC1X1./distsX1X2;
scales = distsC1X1./distsC1X2;

scale = median(scales);
X2_scaled = reconstructPoint(x2,x3,R1,C1,R1*R2,R1*(scale*C2),K2,K3);

h = figure(4); clf; hold on;
scatter3(X1(1,:),X1(2,:),X1(3,:),'MarkerEdgeColor','r')
scatter3(X2(1,:),X2(2,:),X2(3,:),'MarkerEdgeColor','y')
scatter3(X2_scaled(1,:),X2_scaled(2,:),X2_scaled(3,:),'MarkerEdgeColor','b')
C2_r = R1*C2;
drawCamera(eye(3),[0;0;0],0.2,h,struct('Color','r'));
drawCamera(R1,C1,0.2,h,struct('Color','g'));
drawCamera(R2,C2_r,0.2,h,struct('Color','b'));
hold off;

end

