% ROTATIONFROMPANTILT Calculates rotation matrix from pan and tilt.
%
% Usage: [R] = rotationFromPanTilt(pan, tilt)
%  
% Arguments:
%       pan  - pan of camera (in degrees)
%       tilt - tilt of camera (in degrees
%
% Returns:
%       R - rotation matrix
%
% Simply a wrapper for ANGLE2DCM, using pan as rotation around y and tilt
% as rotation around x, with no rotation around z.
%
% See Also: ANGLE2DCM
%
% @author Hanno Jaspers
% @date 2011
function [R] = rotationFromPanTilt(pan, tilt)
    R = angle2dcm(0,deg2rad(pan),deg2rad(tilt));
end

