% m-File to create image lists for shutters closed
%

%% image data directory
imagedir = 'D:\Documents\My Dropbox\Documents\Uni\Paper\Studienarbeit\Bilddatensatz\';


%% Finca
fincadir = 'conference_room_cameras/';

%% create angles

% curtiz
pan = 0:-15:-90; 
tilt = 0:15:60;
pan_z = 0:-10:-90; 
tilt_z = 0:10:60;

[X Y] = meshgrid(tilt, pan);
[Xz Yz] = meshgrid(tilt_z, pan_z);
curtiz_pantilt = [Y(:) X(:)];
curtiz_pantilt_z = [Yz(:) Xz(:)];

% welles
pan = 0:-15:-90; 
tilt = 0:15:60;
pan_z = 0:-10:-90; 
tilt_z = 0:10:60;

[X Y] = meshgrid(tilt, pan);
[Xz Yz] = meshgrid(tilt_z, pan_z);
welles_pantilt = [Y(:) X(:)];
welles_pantilt_z = [Yz(:) Xz(:)];

% godard
pan = 0:-15:-90; 
tilt = 0:15:60;
pan_z = 0:-10:-90; 
tilt_z = 0:10:60;

[X Y] = meshgrid(tilt, pan);
[Xz Yz] = meshgrid(tilt_z, pan_z);
godard_pantilt = [Y(:) X(:)];
godard_pantilt_z = [Yz(:) Xz(:)];

% fassbinder
pan = 120:-15:-15; 
tilt = 0:15:60;
pan_z = 120:-10:-10; 
tilt_z = 0:10:60;

[X Y] = meshgrid(tilt, pan);
[Xz Yz] = meshgrid(tilt_z, pan_z);
fassbinder_pantilt = [Y(:) X(:)];
fassbinder_pantilt_z = [Yz(:) Xz(:)];

clear X Y Xz Yz pan tilt pan_z tilt_z

%% create image lists

% folder, camera index, zoom
imagedirs = { 
'finca_shutters_closed_2011-03-11\curtiz_zoom-0.00_wb-indoor_20110311081146\', 1, 0;
'finca_shutters_closed_2011-03-11\curtiz_zoom-0.00_wb-outdoor_20110311081637\', 1, 0;
'finca_shutters_closed_2011-03-11\curtiz_zoom-0.20_wb-indoor_20110311081324\', 1, 1;
'finca_shutters_closed_2011-03-11\curtiz_zoom-0.20_wb-outdoor_20110311081839\', 1, 1;
'finca_shutters_closed_2011-03-11\fassbinder_zoom-0.00_wb-indoor_20110311081148\', 2, 0;
'finca_shutters_closed_2011-03-11\fassbinder_zoom-0.00_wb-outdoor_20110311081858\', 2, 0;
'finca_shutters_closed_2011-03-11\fassbinder_zoom-0.20_wb-indoor_20110311081407\', 2, 1;
'finca_shutters_closed_2011-03-11\fassbinder_zoom-0.20_wb-outdoor_20110311082116\', 2, 1;
'finca_shutters_closed_2011-03-11\godard_zoom-0.00_wb-indoor_20110311081150\', 4, 0;
'finca_shutters_closed_2011-03-11\godard_zoom-0.00_wb-outdoor_20110311081640\', 4, 0;
'finca_shutters_closed_2011-03-11\godard_zoom-0.20_wb-indoor_20110311081328\', 4, 1;
'finca_shutters_closed_2011-03-11\godard_zoom-0.20_wb-outdoor_20110311081819\', 4, 1;
'finca_shutters_closed_2011-03-11\welles_zoom-0.00_wb-indoor_20110311081148\', 3, 0;
'finca_shutters_closed_2011-03-11\welles_zoom-0.00_wb-outdoor_20110311081640\', 3, 0;
'finca_shutters_closed_2011-03-11\welles_zoom-0.20_wb-indoor_20110311081327\', 3, 1;
'finca_shutters_closed_2011-03-11\welles_zoom-0.20_wb-outdoor_20110311081828\', 3, 1;
'finca_object-variation_2011-03-10\curtiz_zoom-0.00_wb-indoor_20110311090848\', 1, 0;
'finca_object-variation_2011-03-10\curtiz_zoom-0.20_wb-indoor_20110311091027\', 1, 1;
'finca_object-variation_2011-03-10\fassbinder_zoom-0.00_wb-indoor_20110311090849\', 2, 0;
'finca_object-variation_2011-03-10\fassbinder_zoom-0.20_wb-indoor_20110311091111\', 2, 1;
'finca_object-variation_2011-03-10\godard_zoom-0.00_wb-indoor_20110311090901\', 4, 0;
'finca_object-variation_2011-03-10\godard_zoom-0.20_wb-indoor_20110311091040\', 4, 1;
'finca_object-variation_2011-03-10\welles_zoom-0.00_wb-indoor_20110311090850\', 3, 0;
'finca_object-variation_2011-03-10\welles_zoom-0.20_wb-indoor_20110311091029\', 3, 1;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.00_wb-auto_20110311084925\', 1, 0;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.00_wb-indoor_20110311083131\', 1, 0;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.00_wb-outdoor_20110311083623\', 1, 0;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.20_wb-auto_20110311085103\', 1, 1;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.20_wb-indoor_20110311083310\', 1, 1;
'finca_shutters_opened_2011-03-11\curtiz_zoom-0.20_wb-outdoor_20110311083801\', 1, 1;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.00_wb-auto_20110311084926\', 2, 0;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.00_wb-indoor_20110311083132\', 2, 0;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.00_wb-outdoor_20110311083819\', 2, 0;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.20_wb-auto_20110311085145\', 2, 1;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.20_wb-indoor_20110311083351\', 2, 1;
'finca_shutters_opened_2011-03-11\fassbinder_zoom-0.20_wb-outdoor_20110311084038\', 2, 1;
'finca_shutters_opened_2011-03-11\godard_zoom-0.00_wb-auto_20110311084928\', 4, 0;
'finca_shutters_opened_2011-03-11\godard_zoom-0.00_wb-indoor_20110311083134\', 4, 0;
'finca_shutters_opened_2011-03-11\godard_zoom-0.00_wb-outdoor_20110311083626\', 4, 0;
'finca_shutters_opened_2011-03-11\godard_zoom-0.20_wb-auto_20110311085107\', 4, 1;
'finca_shutters_opened_2011-03-11\godard_zoom-0.20_wb-indoor_20110311083312\', 4, 1;
'finca_shutters_opened_2011-03-11\godard_zoom-0.20_wb-outdoor_20110311083804\', 4, 1;
'finca_shutters_opened_2011-03-11\welles_zoom-0.00_wb-auto_20110311084927\', 3, 0;
'finca_shutters_opened_2011-03-11\welles_zoom-0.00_wb-indoor_20110311083133\', 3, 0;
'finca_shutters_opened_2011-03-11\welles_zoom-0.00_wb-outdoor_20110311083625\', 3, 0;
'finca_shutters_opened_2011-03-11\welles_zoom-0.20_wb-auto_20110311085105\', 3, 1;
'finca_shutters_opened_2011-03-11\welles_zoom-0.20_wb-indoor_20110311083311\', 3, 1;
'finca_shutters_opened_2011-03-11\welles_zoom-0.20_wb-outdoor_20110311083803\', 3, 1};

for i=1:size(imagedirs,1)
    dc = dir([imagedir fincadir imagedirs{i,1} '*.jpg']);
    variable = '';
    
    switch imagedirs{i,2}
        case 1
            variable = 'curtiz_pantilt';
        case 2
            variable = 'fassbinder_pantilt';
        case 3
            variable = 'welles_pantilt';
        case 4
            variable = 'godard_pantilt';
    end     
    
    if imagedirs{i,3} == 1
        tmp = eval([variable '_z']);
    else
        tmp = eval(variable);
    end
    
    fid = fopen([imagedir fincadir imagedirs{i,1} 'imagelist.txt'],'wt');
    fprintf(fid, '# filename                        pan   tilt\n');
    for k=1:size(dc,1)
        %curtiz_images{k,1} = dc(k).name;
        %curtiz_images{k,2} = curtiz_pantilt(k,:);
        fprintf(fid, '%s %6.2d %6.2d\n', dc(k).name, tmp(k,:));
    end
    fclose(fid);
end