function visualizeRelativeSolution(R,C,X,correctSolution,figureNo)
%VISUALIZERELATIVESOLUTION Summary of this function goes here
%  
% Usage: visualizeRelativeSolution(R,C,X,figureNo)
%        visualizeRelativeSolution(Rs,Cs,X,correctSolution,figureNo)
%

    if nargin == 4
        multiSolution = false;
        figureNo = correctSolution;
    elseif nargin == 5
        multiSolution = true;
    else
        error('Wrong number or arguments');
    end
            

    % ---------------------------------------------------------------------
    % visualize camera solutions + "real" cam 
    % ---------------------------------------------------------------------
    fh = figure(figureNo);
    clf;
    hold on;
    colours = 'rgbc';
    if multiSolution
        for i=1:4
            if i==correctSolution
                addOpts = struct('Color',colours(i),'LineWidth',2);
            else
                addOpts = struct('Color',colours(i));
            end
            drawCamera(R{i},C{i},0.1,fh,addOpts);
        end
        drawCamera(eye(3),[0 0 0]',0.1,fh,struct('Color','y'));
    else
        drawCamera(R,C,0.1,fh,struct('Color','b'));
        drawCamera(eye(3),[0 0 0]',0.1,fh,struct('Color','r'));
    end
    
    
    % ---------------------------------------------------------------------
    % Reconstruct points
    % ---------------------------------------------------------------------
    % first: throw out points, that are probably outliers --> simple
    % distance criterion
    Xm = X-repmat(mean(X,2),1,size(X,2));
    % distance to mean:
    Xdists = sqrt(sum(Xm.^2));
    % throw out those, whose distance is greater than 2*std(Xdists)
    X_red = X(:,Xdists < 2*std(Xdists));
    
    %fprintf('Threw out %d points.\n',length(X)-length(X_red));
    
    scatter3(X_red(1,:),X_red(2,:),X_red(3,:));
    hold off;
end

